Foreman - Bug #2948

Whitelist additional Provisioning Template Macros
08/19/2013 07:33 PM - Ronny M

Status: Closed
Priority: Normal
Assignee: Lukas Zapletal
Category: Templates
Target version: 1.7.2
Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.71
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2102
Description

If would like to have the following Provisioning Template macro's white listed so they can be used in templates with

savemode_render set to true in provisioning settings.
@host.interfaces.size
@host.interfaces.empty

Related issues:

Related to Foreman - Bug #3602: Provisioning templates do not support all the... Duplicate 11/07/2013
Related to Boot disk - Support #4184: undefined method 'mask’ for Safemode::J... Closed 01/25/2014
Related to Discovery - Bug #9077: Hostname templating does not work with fact... Closed 01/22/2015

Associated revisions

Revision 13d9564d - 01/24/2015 06:42 AM - Lukas Zapletal
Fixes #2948 - added sp_* host attributes to safe mode

Refs #2948 - Add sp__ host attributes to jail test
Revision faeca375 - 01/27/2015 11:12 AM - Lukas Zapletal
Fixes #2948 - added sp_* host attributes to safe mode

Refs #2948 - Add sp__ host attributes to jail test

(cherry picked from commit 13d9564d3b64da23aafd0e8dc6d243a8f032dd2c)

History

#1 - 08/20/2013 02:21 PM - Ronny M

Forgot to mention that this is about foreman 1.2 and 1.2.1 but | assume that it is valid for older releases as well.

#2 - 08/22/2013 05:08 PM - Ronny M

The following macro's also only work if savemode_render is set to false which | would like to have white-listed so | they can be used with

savemode_render is true.

@host.interfaces.bmc.first
@host.interfaces.bmec.first.username
@host.interfaces.bmc.first.password
@host.sp_ip

@host.sp_subnet
@host.sp_subnet.mask
@host.sp_subnet.gateway

#3 - 08/23/2013 06:54 AM - Lukas Zapletal
- Category set to Templates

- Target version set to 1.3.0
Hey Ronny,
go ahead; edit that and test that, it is defined in: lib/foreman/renderer.rb

| see you already edited http://projects.theforeman.org/projects/foreman/wiki/TemplateWriting - it's a bit early for this as the feature is not there yet.

#4 - 08/25/2013 08:00 AM - Ronny M

Ok, | will do that and test it.

In my wiki updates there is a note that savemode_render should be set to false for it to work. :)
But | can remove the updates if you wish?

But then the entries about bmc (not made by me) in the wiki should probably also be removed, because they also only work if savemode_render is
disabled.

#5 - 08/27/2013 07:00 AM - Lukas Zapletal

Right | missed the note on the wiki, this is fine. Right. If you need assistance with your contribution, dont hesitate to ping me on IRC! Thank you.

#6 - 09/16/2013 12:15 PM - Lukas Zapletal

- Target version changed from 1.3.0 to 1.4.0

#7 - 09/19/2013 05:30 PM - Ronny M

For some reason | keep getting "http 500 errors" when viewing a template if | try to white-list methods in /usr/share/foreman/lib/foreman/renderer.rb
and use them in my provisioning templates.

What | did:
With safemode_render set to false:
Added for example ", :sp_ip" to allowed_helpers as shown below:

allowed_helpers = [ :foreman_url, :grub_pass, :snippet, :snippets, :ks_console, :root_pass, :multiboot, ;jumpstart_path, :install_path,
:miniroot, :media_path, :sp_ip ]

Restarted everything to make sure changes are effective, also tried a reboot.
Viewing a template is now still ok.
Then added the following line using the template edit button for my host.
1. <%= @host.sp_ip %>
Viewing the template still ok.
Then set safemode_render to true:
Error 500 when trying to view template and in logging.
Unfortunately no extra information in foreman debug log the explains what went wrong.
Any Ideas what is going wrong?

#8 - 09/19/2013 05:36 PM - Ronny M

The 1. before <%= @host.sp_ip %> is a hash but replaced by the wiki with .1, and forgot to mention that the right ip address is shown in the template
with safemode_render set to false.

#9 - 10/16/2013 03:42 PM - Greg Sutcliffe
- Target version deleted (1.4.0)

#10 - 11/07/2013 05:39 PM - Dominic Cleal
- Related to Bug #3602: Provisioning templates do not support all the documented functions added

#11 - 01/15/2014 06:30 PM - Greg Sutcliffe

The bootdisk iPXE example templates also have Safemode problems. Specifically the methods

Redhat .url_for_boot ()
Debian.boot_files_uri ()
http://projects.theforeman.org/projects/foreman/wiki/TemplateWriting

which are used to get direct download links for the kernel/initrd from the install media. Neither work correctly in Safemode. In addtion,
Debian.boot_files_uri requires @host.medium as an argument, which also cannot be rendered.

#12 - 01/23/2014 11:08 PM - Dominic Cleal

host.facts_hash, host.facts_hash['foo'] should also be available.

#13 - 01/29/2014 04:07 PM - Dominic Cleal

There | some | use in bootdisk too, see #4184.

#14 - 01/29/2014 04:08 PM - Dominic Cleal
- Related to Support #4184: undefined method 'mask’ for Safemode::Jail (NilClass) added

#15 - 03/06/2014 10:47 AM - Matt Darcy

puppet_ca_server on hostgroups will also need whitelisting, I'd expect also

ca_server = <%= @host.puppet_ca_server >
certname = <= @host.certname >
environment = <= @host.environment >
server = <= @host.puppetmaster %>

will need to be updated in hostgroups as | believe I'm only getting the error on puppet_ca_server is it's the first one in the list of the puppet.conf
snippet.

#16 - 03/31/2014 03:34 PM - Dominic Cleal
@host.token.nil? in the default iPXE template fails too:

There was an error rendering the Kickstart default iPXE template: undefined method 'nil?' for Safemode::Jail (
Token)

#17 - 01/22/2015 06:53 AM - Dominic Cleal
Dominic Cleal wrote:
@host.token.nil? in the default iPXE template fails too:

There was an error rendering the Kickstart default iPXE template: undefined method 'nil?' for Safemode::Jail (Token)

Fixed in #5708.

#18 - 01/22/2015 07:00 AM - Lukas Zapletal
- Related to Bug #9077: Hostname templating does not work with facts_hash added

#19 - 01/22/2015 08:39 AM - Lukas Zapletal
- Status changed from New to Assigned

- Assignee set to Lukas Zapletal

| have reviewed our docs while working on this issue:

http:/projects.theforeman.org/projects/foreman/wiki/Template Writing/diff ?utf8=%E2%9C%93&version=71&version_from=70&commit=View+differenc
es

Also as part of this review, added "facts" alias. Attribute "facts_hash" was never exposed via safemode.

#20 - 01/22/2015 08:42 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2102 added
- Pull request deleted ()

#21 - 01/22/2015 08:43 AM - Lukas Zapletal

- Target version set to 1.7.2

Setting release to 1.7.1 for backporting.
https://projects.theforeman.org/issues/4184
http://projects.theforeman.org/projects/foreman/wiki/TemplateWriting/diff?utf8=%E2%9C%93&version=71&version_from=70&commit=View+differences
http://projects.theforeman.org/projects/foreman/wiki/TemplateWriting/diff?utf8=%E2%9C%93&version=71&version_from=70&commit=View+differences

#22 - 01/24/2015 07:01 AM - Lukas Zapletal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 13d9564d3b64da23aafd0e8dc6d243a8f032dd2c.

#23 - 01/26/2015 04:31 AM - Dominic Cleal

- translation missing: en.field_release set to 30
